#ifndef YACE_OBJECT_MANAGER_H
#define YACE_OBJECT_MANAGER_H

#include "pre.h"

#include "os.h"
#include "yace_export.h"

// forward decvlarations

// configuration parameters
#if !defined(YACE_MAX_MANAGED_OBJECTS)
#	define YACE_MAX_MANAGED_OBJECTS 128
#endif

class YACE_Export YACE_Object_Manager : public YACE_Object_Manager_Base
{
public:
	virtual int init();
	virtual int fini();

	static int starting_up();
	static int shutting_down();

	static int at_exit(YACE_Cleanup* object, void* param = 0);
	static int at_exit(void* object,
			   YACE_CLEANUP_FUNC cleanup_hook,
			   void* param);
private:
	YACE_OS_Exit_Info exit_info_;
	int at_exit_i(void* object, YACE_CLEANUP_FUNC cleanup_hook, void* param);

public:
	static YACE_Object_Manager* instance();

	YACE_Object_Manager();
	~YACE_Object_Manager();

private:
	// singleton pointer
	static YACE_Object_Manager* instance_;

	// disallow copying by not implementing the following..
	YACE_Object_Manager(const YACE_Object_Manager& );
	YACE_Object_Manager& operator= (const YACE_Object_Manager &);

};

#endif	// YACE_OBJECT_MANAGER_H